package com

import scala.collection.JavaConverters._
/*
  Movies application has data for movies as comma separated values in csv files.
  Application can do the following for It’s Users.
  User can:
  1. Query to get a List of All Movies.
  2. Query any Movie Information by providing Movie Name.
  3. Query any Movie Information by providing Release Year.
  4. Exit
*/

object Analysis extends App {
  println(
    """************************************
      | WELCOME TO Movies Analysis APP
      |************************************
        """.stripMargin)

  listAllOptions

//  Initialization of variable 'movies'
  lazy val movies = try {
    val bufferedSource = scala.io.Source.fromFile("data/movies.csv")
    val arrOflines = try bufferedSource.getLines.toArray finally bufferedSource.close()
    val linesStream = arrOflines.drop(1).toStream
    val movies = new java.util.ArrayList[Movie]()
    linesStream foreach (line => {
      val cols = line.split(',').toArray
      movies.add(Movie(cols(0), cols(1).stripSuffix("\"").stripPrefix("\""), cols(2), cols(3), cols(4)))
    })
    movies.asScala.toList
  } catch {
    case e: Exception => e.printStackTrace
      List[Movie]()
  }

//  Methods are defined for 'list of all movies'
  def listAllMovies(movies: List[Movie]) = {
    println("\n***********************************************************")
    movies foreach (movies => {
      println(movies)
    })
    println("***********************************************************\n")
  }

//  Methods are defined for 'get movies by name'
  def movieInformationByName(movies: List[Movie]) = {
    print("Please Enter Movie Name: ")
    val input = scala.io.StdIn.readLine()
    val filterMovies = movies.filter(movie => {
      ((movie.title).toLowerCase()).contains(input.toLowerCase())
    })
    println("\n***********************************************************")
    if (!filterMovies.isEmpty) {
      filterMovies foreach (movie => {
        println(movie)
      })
    } else {
      println("No Movie Found with given Input")
    }
    println("***********************************************************\n")
  }

//  Methods are defined for 'get movies by release year'
  def movieInformationByDate(movies: List[Movie]) = {
    print("Please Enter Movie Release Year: ")
    val input = scala.io.StdIn.readLine()
    val filterMovies = movies.filter(movie => {
      (movie.date).contains(input)
    })
    println("\n***********************************************************")
    if (!filterMovies.isEmpty) {
      filterMovies foreach (movie => {
        println(movie)
      })
    } else {
      println("No Movie Found with given Input")
    }
    println("***********************************************************\n")
  }

//  Methods are defined for 'show application option'
  def listAllOptions: Unit = {
    println("-----------------------------------------------------------")
    println(
      """Please Choose any Option to Proceed:
        |1. List All Movies
        |2. Movie Information By Movie Name
        |3. Movie Information By Movie Release Date
        |4. Exit""".stripMargin)
    println("-----------------------------------------------------------")
    print("Option :: ")

    scala.io.StdIn.readInt() match {
      case 1 => listAllMovies(movies); println; listAllOptions
      case 2 => movieInformationByName(movies); println; listAllOptions
      case 3 => movieInformationByDate(movies); println; listAllOptions
      case 4 =>
        println("\n***********************************************************")
        println("Thank You.")
        println("***********************************************************\n")
      case _ =>
        println("\n***********************************************************")
        println("Seems You've chosen the wrong Option.");
        println("***********************************************************\n")
        listAllOptions
    }
  }

}

case class Movie(id: String, title: String, budget: String, gross: String, date: String)
